diff -u -Naur eperl-2.2.14/eperl_sys.c eperl-2.2.14.fink/eperl_sys.c
--- eperl-2.2.14/eperl_sys.c	Mon Jul 27 04:41:34 1998
+++ eperl-2.2.14.fink/eperl_sys.c	Wed Nov 17 12:45:58 2004
@@ -15,7 +15,7 @@
 **
 **  ======================================================================
 **
-**  Copyright (c) 1996,1997,1998 Ralf S. Engelschall <rse@engelschall.com>
+**  Copyright (c) 1996,1997,1998,1999 Ralf S. Engelschall <rse@engelschall.com>
 **
 **  This program is free software; it may be redistributed and/or modified
 **  only under the terms of either the Artistic License or the GNU General
@@ -37,12 +37,16 @@
 #include "eperl_global.h"
 #include "eperl_proto.h"
 
+char * getenv ();
 
 /*
 **
 **  own setenv() function which works with Perl
 **
 */
+
+extern char **environ;
+
 char **mysetenv(char **env, char *var, char *str, ...)
 {
     va_list ap;
@@ -51,14 +55,15 @@
     char *cp;
     int i;
     char **envN;
-    extern char **environ;
     static int stillcalled = FALSE;
     int replaced = FALSE;
 
     /*  create the key=val string  */
     va_start(ap, str);
-    vsprintf(ca, str, ap);
-    sprintf(ca2, "%s=%s", var, ca);
+    vsnprintf(ca, sizeof(ca), str, ap);
+    ca[sizeof(ca)-1] = NUL;
+    snprintf(ca2, sizeof(ca2), "%s=%s", var, ca);
+    ca2[sizeof(ca2)-1] = NUL;
     cp = strdup(ca2);
 
     /*  now duplicate the old structure  */
@@ -77,8 +82,8 @@
     /*  add the new entry if not replaced */
     if (!replaced) {
         envN[i++] = cp;
-        envN[i++] = NULL;
     }
+    envN[i] = NULL;
 
     /*  set the libc/exec variable which Perl uses */
     if (stillcalled) 
@@ -205,10 +210,15 @@
 char *mytmpfile(char *id)
 {
     char ca[1024];
-    char *cp;
+    char *cp, *tmpdir;
     int i;
 
-    sprintf(ca, "/tmp/%s.%d.tmp%d", id, (int)getpid(), mytmpfilecnt++);
+    tmpdir = getenv ("TMPDIR");
+    if (tmpdir == (char *) NULL)
+        tmpdir="/tmp";
+
+    snprintf(ca, sizeof(ca), "%s/%s.%d.tmp%d", tmpdir, id, (int)getpid(), mytmpfilecnt++);
+    ca[sizeof(ca)-1] = NUL;
     cp = strdup(ca);
     for (i = 0; mytmpfiles[i] != NULL; i++)
         ;
@@ -239,8 +249,8 @@
     char timestr[128];
 
     tm = localtime(t);
-    sprintf(timestr, "%02d-%02d-19%02d %02d:%02d",
-                      tm->tm_mday, tm->tm_mon+1, tm->tm_year,
+    sprintf(timestr, "%02d-%02d-%04d %02d:%02d",
+                      tm->tm_mday, tm->tm_mon+1, tm->tm_year+1900,
                       tm->tm_hour, tm->tm_min);
     return strdup(timestr);
 }
@@ -257,13 +267,14 @@
     FILE *fp = NULL;
     char *cpBuf = NULL;
     int nBuf;
-    char tmpfile[256];
+    char tmpfile[256], *ptr_tmpfile;
     int usetmp = 0;
     int c;
 
     if (stringEQ(filename, "-")) {
         /* file is given on stdin */
-        sprintf(tmpfile, "/tmp/eperl.tmp.%d", (int)getpid());
+        ptr_tmpfile = mytmpfile("ePerl.source");
+        sprintf(tmpfile, "%s", ptr_tmpfile);
         if ((fp = fopen(tmpfile, "w")) == NULL) {
             ePerl_SetError("Cannot open temporary source file %s for writing", tmpfile);
             CU(NULL);
@@ -384,7 +395,8 @@
             ;
         if (cp == path+1)
             cp--;
-        strcpy(file, cp);
+        strncpy(file, cp, sizeof(file));
+        file[sizeof(file)-1] = '\0';
         return file;
     }
 }
@@ -397,7 +409,8 @@
     if (path[strlen(path)-1] == '/')
         return path;
     else {
-        strcpy(dir, path);
+        strncpy(dir, path, sizeof(dir));
+        dir[sizeof(dir)-1] = '\0';
         for (cp = dir+strlen(dir); cp > dir && *(cp-1) != '/'; cp--)
             ;
         *cp = NUL;
@@ -423,9 +436,12 @@
         /* restore cwd */
         chdir(cwd);
         /* add file part again */
-        if (apath[strlen(apath)-1] != '/')
-            strcpy(apath+strlen(apath), "/");
-        strcpy(apath+strlen(apath), path);
+        if (apath[strlen(apath)-1] != '/') {
+            strncpy(apath+strlen(apath), "/", sizeof(apath)-strlen(apath));
+            apath[sizeof(apath)-1] = '\0';
+        }
+        strncpy(apath+strlen(apath), path, sizeof(apath)-strlen(apath));
+        apath[sizeof(apath)-1] = '\0';
         return apath;
     }
 }
diff -u -Naur eperl-2.2.14/etc/asc2c eperl-2.2.14.fink/etc/asc2c
--- eperl-2.2.14/etc/asc2c	Tue Jan  7 08:36:49 1997
+++ eperl-2.2.14.fink/etc/asc2c	Wed Nov 17 12:45:58 2004
@@ -1,4 +1,6 @@
-#!/sw/bin/perl
+:
+eval 'exec perl -S $0 ${1+"$@"}'
+    if $running_under_some_shell;
 ##
 ##  asc2c -- convert an ASCII file into a statically initialised
 ##           C array of characters
diff -u -Naur eperl-2.2.14/etc/mkproto eperl-2.2.14.fink/etc/mkproto
--- eperl-2.2.14/etc/mkproto	Mon Jul 14 13:12:33 1997
+++ eperl-2.2.14.fink/etc/mkproto	Wed Nov 17 12:45:58 2004
@@ -1,4 +1,6 @@
-#!/sw/bin/perl
+:
+eval 'exec perl -S $0 ${1+"$@"}'
+    if $running_under_some_shell;
 
 $header = $ARGV[0];
 shift @ARGV;
diff -u -Naur eperl-2.2.14/etc/newvers eperl-2.2.14.fink/etc/newvers
--- eperl-2.2.14/etc/newvers	Sat Apr  4 07:31:28 1998
+++ eperl-2.2.14.fink/etc/newvers	Wed Nov 17 12:45:58 2004
@@ -182,7 +182,7 @@
                     bplevel=0
                     ;;
             esac
-            date=`date '+%d-%m-19%y'`
+            date=`date '+%d-%m-%Y'`
         fi
 
     else
@@ -191,7 +191,7 @@
         revision=5
         bptype=b
         bplevel=0
-        date=`date '+%d-%m-19%y'`
+        date=`date '+%d-%m-%Y'`
     fi
 else
     #   take given version
@@ -200,7 +200,7 @@
     revision=`echo $VERSION | awk -F: '{ print $2 }'`
     bptype=`echo $VERSION | awk -F: '{ print $3 }'`
     bplevel=`echo $VERSION | awk -F: '{ print $4 }'`
-    date=`date '+%d-%m-19%y'`
+    date=`date '+%d-%m-%Y'`
 fi
 
 if [ $REPORT = YES ]; then
@@ -215,7 +215,7 @@
 fi
 
 #   create date string
-year=`date '+19%y'`
+year=`date '+%Y'`
 month=`date '+%m'`
 day=`date '+%d'`
 
